#include <avr/pgmspace.h>
#include "pitches.h"

PROGMEM prog_uint16_t SmoothCriminalTune[] = {
NOTE_00, 480, NOTE_A3, 120, NOTE_00, 120, NOTE_A3, 120, NOTE_00, 120, NOTE_A3, 120, NOTE_00, 120, NOTE_A3, 240, NOTE_G3, 240, NOTE_A3, 240, NOTE_B3, 480, NOTE_B3, 240, NOTE_00, 240, NOTE_00, 240, NOTE_A3, 120, NOTE_00, 120, NOTE_A3, 180, NOTE_00, 60, NOTE_B3, 240, 
NOTE_C4, 480, NOTE_C4, 480, NOTE_00, 480, NOTE_B3, 180, NOTE_00, 60, NOTE_C4, 240, NOTE_B3, 480, NOTE_G3, 480, NOTE_00, 960, 
};
byte SmoothCriminalTuneSteps = 28;

unsigned long time = 0;
int tuneStep = 0;
byte speakerPin=12;

void restart_melody()
{
  time=millis();
  tuneStep=0;
  noTone(speakerPin);
}

boolean playMelody()
{
  boolean retVal=true;
  if (millis() > time) {
    int toneVal = 0;
    int duration = 0;
    if (tuneStep >= SmoothCriminalTuneSteps) {
      retVal=false;
      tuneStep=0;
    }
    toneVal=pgm_read_word_near(SmoothCriminalTune+(tuneStep*2));
    duration = pgm_read_word_near(SmoothCriminalTune+(tuneStep*2)+1);
    tuneStep++;
    if (toneVal) tone(speakerPin,toneVal,duration*2);
    time=millis()+(duration*2)+5;
  }
  return retVal;
}

void setup()
{
}

void loop()
{
  playMelody();
  delay(10);
}
